#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#define SUFLEN 7 /* suffix length */

/* ANSI C splitting program */
char *version="$VER: SpezzaFile 1.0 (12.04.2003) by Sante Nocciolino";
void int2str(int,char*,int);
void upper(char *);

int main(int argc,char *argv[])
{
    FILE *infh,*outfh;
    char *buffer;
    int i,count=0,buf_size;
    char outf[64];
    char suffix[SUFLEN];

    if (argc!=4) {
        printf("Usage: %s INFILE OUTBASE DIM\n",argv[0]);
        puts("   INFILE is the file you want to split");
        puts("   OUTBASE will be the prefix of the output files");
        puts("   DIM you can specify:");
        puts("       - the dimension in bytes of single piece");
        puts("       - DDFFS for pieces that fit on double density FFS formatted floppies (Amiga)");
        puts("       - HDFFS for pieces that fit on high density OFS formatted floppies (Amiga)");
        puts("       - DDOFS for pieces that fit on double density OFS formatted floppies (Amiga)");
        puts("       - HDOFS for pieces that fit on high density OFS formatted floppies (Amiga)");
        puts("       - DDPC for pieces that fit on double density PC formatted floppies");
        puts("       - HDPC  for pieces that fit on high density PC formatted floppies");
        return(10);
    }
    
    strcpy(outf,argv[2]);
    upper(argv[3]);
    printf("%s\n",argv[3]);
    if ((strcmp(argv[3],"DDFFS"))==0) buf_size=886272;
    else if ((strcmp(argv[3],"DDOFS"))==0) buf_size=844728;
    else if ((strcmp(argv[3],"DDPC"))==0) buf_size=730112;
    else if ((strcmp(argv[3],"HDPC"))==0) buf_size=1457664;
    else if ((strcmp(argv[3],"HDFFS"))==0) buf_size=1775104;
    else if ((strcmp(argv[3],"HDOFS"))==0) buf_size=1691896;
    else buf_size=atoi(argv[3]);
    if (buf_size==0) {
        puts("Error in parameters");
        return(10);
        }
    
    if((infh=fopen(argv[1],"r"))==NULL) {
      puts("Error opening input file");
      return(10);
    }

    buffer=(char*)malloc(sizeof(char)*buf_size);
    puts("FFS or OFS floppies must be formatted without DIRECTORY CACHE and without TRASHCAN!!!");
    printf("...splitting in pieces of %i bytes...\n",buf_size);
    while(!(feof(infh))) {
        outf[0]=0;

        int2str(count,suffix,SUFLEN);
        
        strcat(outf,argv[2]);
        strcat(outf,".");
        strcat(outf,suffix);
    
        if((outfh=fopen(outf,"w"))==NULL) {
           puts("Error opening target file");
           free(buffer);
           fclose(infh);
           return(21);
        }
        for (i=0;i<buf_size && !(feof(infh));i++) buffer[i]=fgetc(infh);
    if (!(feof(infh))) fwrite(buffer,i,1,outfh);
        else fwrite(buffer,i-1,1,outfh);
    fclose(outfh);
    count++;
    }
    fclose(infh);
    free(buffer);
    printf("File is splitted into %d pieces!\n",count);
    return(0);

}

/* this function converts an integer to a string of fixed length
   and attaches to the string the approriate leading zeroes to
   give the string the requested length */
void int2str(int count,char *string,int length)
{
  int i;
  
  for (i=0;i<length-1;i++)
    {
      string[length-2-i]=(count%10)+0x30;
      count=count/10;
    }
  string[length-1]='\0';
  return;
}

/* this function converts a string to upper case */
void upper(char *string)
{
  int i,c;

  c=strlen(string);
  for(i=0;i<c;i++) if (string[i]>0x60 && string[i]<0x7b) string[i]-=0x20;
  return;
}
 
/* this function copies a string from destr to src */
char * mystrcpy(char * dest,const char *src)
{
    char *tmp = dest;

    while ((*dest++ = *src++) != '\0')
        /* nothing */;
    return tmp;
}